<!-- markdownlint-configure-file {
  "MD013": {
    "code_blocks": false,
    "tables": false
  },
  "MD033": false,
  "MD041": false
} -->

<a name="readme-top"></a>

<div align="center">

[![latest release](https://gitlab.com/venafi/vaas/applications/tls-protect-for-k8s/venctl/-/badges/release.svg)](https://gitlab.com/venafi/vaas/applications/tls-protect-for-k8s/venctl/-/releases)
[![pipeline status](https://gitlab.com/venafi/vaas/applications/tls-protect-for-k8s/venctl/badges/master/pipeline.svg)](https://gitlab.com/venafi/vaas/applications/tls-protect-for-k8s/venctl/-/commits/master)
[![nix devshell](https://img.shields.io/badge/nix-devshell-blue?logo=NixOS)](https://gitlab.com/venafi/vaas/applications/tls-protect-for-k8s/venctl)

# venctl

<a href="http://clouddocsdev.s3-website-us-west-2.amazonaws.com/VC-27303/vaas/venctl/c-venctl-overview/"><strong>Explore the docs »</strong></a>

<a href="http://clouddocsdev.s3-website-us-west-2.amazonaws.com/VC-27303/vaas/venctl/t-venctl-install/">**Installation**</a>
·
<a href="http://clouddocsdev.s3-website-us-west-2.amazonaws.com/VC-27303/vaas/venctl/c-venctl-reference/">**Reference**</a>

</div>

---

> **Note**
> this aims to be a CLI for the VaaS Control Plane to be the one tool for all users

![demo](./static/demo.gif)

## Usage

### Cluster Connection

#### Prerequisites

* Access to a kubernetes cluster
* API key from valid Venafi Control Plane tenant.

The following steps connect a cluster to Venafi Control plane installing the venafi agent in the `venafi` namespace. 

```shell
export VEN_API_KEY=xx
venctl installation cluster connect --name "my-cluster" --description="new cluster"
```

Check the pod status.

```shell
kubectl get po -n venafi
NAME                     READY   STATUS    RESTARTS   AGE
agent-69d6788d6f-k5zth   1/1     Running   0          40m
```

## Development

When working on the CLI, it's useful to have a devstack [available](https://gitlab.com/venafi/vaas/delivery/devstacks/-/pipelines/new),
instead of using the production venafi instance, plus a KinD cluster running your local machine where the agent can be deployed.
Load the latest image of the venafi agent to your KinD cluster, if it's not present, `kind load docker-image registry.venafi.cloud/venafi-agent/venafi-agent:v0.1.43`.
To make `venctl` target the devstack make sure to pass the `--api-url` plus the `hhttps://api-devXXX.qa.venafi.io/`.

> **Warning**
> Make sure to disable perimeter81, before testing on KinD as it may cause issues for the venafi agent to connect.

Check [CONTRIBUTING.md](.gitlab/CONTRIBUTING.md).

### Makefile
A Makefile is available, the targets are defined under `./make`.

```shell
build
lint
push-container
push-multiarch-manifest
release-clean
build-container
clean
format
release
test
vet
```

### Nix
> **Warning**
> It requires Nix present on the host machine.

A Nix development shell is also available and gives you access to a predefined development environment.

```shell
source env-dev.sh
develop
```

```shell
Venctl Development Shell
The environment is using go.1.21, to update it update the packages below.

Commands:
* lint: runs linter.
* generate: alias for go generate.
* test: runs unit tests.
* fmt: formats go code.
* verify: runs all the checks.

Remember to do a "go mod tidy" before pushing changes.

Use CTRL-D to leave the shell

[venctl-develpment-shell]$
```

## Make a release

The repo uses [goreleaser](https://goreleaser.com/) to build and release the different artifacts, which are available [here](https://gitlab.com/venafi/vaas/applications/tls-protect-for-k8s/venctl/-/releases)
and in [s3](https://venafi-cloud-dl-assets/venctl).

1. Check the latest available release [here](https://gitlab.com/venafi/vaas/applications/tls-protect-for-k8s/venctl/-/releases).
2. Create a new git tag that follows the semver pattern.
    ```shell
    git tag -a v0.1.0 -m "First release"
    git push origin v0.1.0
    ```
3. The new tag will trigger the release [workflow](.gitlab-ci.yml).

## Local build

`make release` will generate all the files needed for a release in `./release`.

`make release -j X` will run X jobs in parallel, speeding up the release build process.

## TO-DOs

- docker builds (multiarch)
- fips image
- make sure it can be built from mac
- helm chart
- k8s raw manifest
- add agent functionality
- add tests in makefile
- add license and report open source licenses
- double-check name is ok
- and all the real functionality
